package org.jpn.xucker.optipngwrapper;/*
                 * Created on 2004/06/27
                 * 
                 * Author aki@www.xucker.jpn.org License Apache2.0 or Common
                 * Public License
                 */

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLDecoder;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CCombo;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeEvent;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeListener;
import org.jpn.xucker.commons.swt.ui.FileListTable;


public class OptiPngWrap implements SelectionListener ,FileStatusChangeListener,Runnable{
    /**
     * @param shell
     */
    private Group group1;

    private Button sameoutput;

    private Text outputLabel;

    private Button outputButton;

    private Group group2;

    private Button dobackup;

    private Button optimizeButton;

    private Group group3;

    private Table table1;

    private Group group4;

    private CCombo level;

    private Text optiPngLabel;

    private Button optiPngButton;

    private FileListTable listTable;

    private Shell shell;

    private Image logoImage;
    
    private double version=0.4;

    public OptiPngWrap(Shell shell) {
        this.shell = shell;
        shell.setText("OptiPngWrapper(PNGœK) v"+version);
        shell.setBounds(0, 0, 500, 400);
        RowLayout layout = new RowLayout();
        shell.setLayout(layout);
        group1 = new Group(shell, SWT.NULL);
        group1.setText("o");
        RowData group1_data = new RowData();
        group1_data.width = 480;
        group1.setLayoutData(group1_data);
        RowLayout group1_layout = new RowLayout();
        group1.setLayout(group1_layout);

        sameoutput = new Button(group1, SWT.NULL | SWT.CHECK);
        sameoutput.setText("͂㏑");
        sameoutput.addSelectionListener(this);
        RowData sameoutput_data = new RowData();
        sameoutput.setLayoutData(sameoutput_data);

        outputLabel = new Text(group1, SWT.READ_ONLY);
        outputLabel.setText("");
        outputLabel
                .setBackground(new Color(Display.getCurrent(), 255, 255, 255));
        RowData outputLabel_data = new RowData();
        outputLabel_data.width = 200;
        outputLabel.setLayoutData(outputLabel_data);

        Transfer[] types = new Transfer[] { FileTransfer.getInstance() };

        int operations = DND.DROP_MOVE | DND.DROP_COPY;

        DropTarget target2 = new DropTarget(outputLabel, operations);
        target2.setTransfer(types);

        target2.addDropListener(new DropMonitor());

        //o͐tH_[
        outputButton = new Button(group1, SWT.NULL);
        outputButton.setText("o͐tH_[");
        outputButton.addSelectionListener(this);
        RowData outputButton_data = new RowData();
        outputButton.setLayoutData(outputButton_data);

        group2 = new Group(shell, SWT.NULL);
        group2.setText("IvV");
        RowData group2_data = new RowData();
        group2_data.width = 480;
        group2.setLayoutData(group2_data);
        RowLayout group2_layout = new RowLayout();
        group2.setLayout(group2_layout);

        dobackup = new Button(group2, SWT.NULL | SWT.CHECK);
        dobackup.setText("œKOɃobNAbv");
        dobackup.setSelection(true);
        dobackup.addSelectionListener(this);
        RowData dobackup_data = new RowData();
        dobackup.setLayoutData(dobackup_data);

        group3 = new Group(shell, SWT.NULL);
        group3.setText("");
        RowData group3_data = new RowData();
        group3_data.width = 480;
        group3.setLayoutData(group3_data);
        RowLayout group3_layout = new RowLayout();
        group3.setLayout(group3_layout);

        listTable = new FileListTable(group3, SWT.NULL);
        listTable.addFileListChangeListener(this);
        String png[]={"png"};
        listTable.setFileExtension(png);
        table1 = listTable.getTable();
        table1.setLinesVisible(true);

        RowData table1_data = new RowData();
        table1_data.width = 455;
        table1_data.height = 130;
        table1.setLayoutData(table1_data);
        TableColumn table1_column = new TableColumn(table1, SWT.NULL);
        table1_column.setWidth(470);

        //œK
        optimizeButton = new Button(shell, SWT.NULL);
        optimizeButton.setText("œK");
        optimizeButton.setEnabled(false);
        optimizeButton.addSelectionListener(this);
        shell.setBackground(new Color(Display.getCurrent(), 255, 255, 255));
        RowData optimizeButton_data = new RowData();
        optimizeButton_data.width = 100;
        optimizeButton_data.height = 50;

        optimizeButton.setLayoutData(optimizeButton_data);
        logoImage = new Image(Display.getCurrent(), FileListTable.class
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/optipngwrapper/resource/optipng.png"));

        Label canvas = new Label(shell, SWT.NULL);
        canvas.setImage(logoImage);
        RowData canvas_data = new RowData();
        canvas_data.width = 350;
        canvas_data.height = 50;
        canvas.setLayoutData(canvas_data);

        group4 = new Group(shell, SWT.NULL);
        group4.setText("OptiPngݒ");
        group4.setBackground(new Color(Display.getCurrent(), 60, 180, 255));

        RowData group4_data = new RowData();
        group4_data.width = 480;
        group4.setLayoutData(group4_data);
        RowLayout group4_layout = new RowLayout();
        group4.setLayout(group4_layout);

        
        Label label=new Label(group4,SWT.NULL);
        label.setText("x");
        level = new CCombo(group4, SWT.NULL);
        for(int i=0;i<=7;i++){
            level.add(""+i);
        }
        
        level.select(5);	//default setting is 7
        
        level.addSelectionListener(this);
        RowData level_data = new RowData();
        level.setLayoutData(level_data);

        optiPngLabel = new Text(group4, SWT.READ_ONLY);
        optiPngLabel.setText("");
        RowData optiPngLabel_data = new RowData();
        optiPngLabel_data.width = 200;
        optiPngLabel.setLayoutData(optiPngLabel_data);

        //optiPngpX
        optiPngButton = new Button(group4, SWT.NULL);
       
        optiPngButton.setText("optiPngpX");
        optiPngButton.addSelectionListener(this);
        RowData optiPngButton_data = new RowData();
        optiPngButton.setLayoutData(optiPngButton_data);

        sameoutput.setSelection(true);
        do_sameoutput();
    }

    public static void main(String[] args) {
        Display display = new Display();
        Shell shell = new Shell(display);

        OptiPngWrap main = new OptiPngWrap(shell);
        
        shell.open();

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
             //   System.out.println("read");
                display.sleep();
            }
        }
        display.dispose();
    }

    public void widgetSelected(SelectionEvent event) {
        Object target = event.getSource();
        
        //͂Ɠ
       if (target == sameoutput) {
            do_sameoutput();
        }
        //o͐tH_[
        else if (target == outputButton) {
            do_outputButton();
        }
        //obNAbv
        else if (target == dobackup) {
            do_dobackup();
        }
        //œK
        else if (target == optimizeButton) {
            do_optimizeButton();
        }
        //null1
        else if (target == table1) {
            do_table1();
        }

        //Level
        else if (target == level) {
            System.out.println(level.getSelectionIndex());
            do_level();
        }
        //optiPngpX
        else if (target == optiPngButton) {
            do_optiPngButton();
        }

    }

    /**
     * 
     */
    OptiPNGExecuter executer=null;
    

    
    public void run(){
       
      
       if(executer!=null){
               try {
            
            executer.execute();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    
        
           shell.getDisplay().syncExec(new CreateResultDialog(executer.getResultData()));
           executing=false;
       }
    }
    
    Thread thread=new Thread(this);

    

    public void widgetDefaultSelected(SelectionEvent arg0) {
        // TODO Auto-generated method stub

    }

    
    //͂Ɠ
    private void do_sameoutput() {
        if (sameoutput.getSelection()) {
            outputButton.setEnabled(false);
            outputLabel.setEnabled(false);
        } else {
            outputButton.setEnabled(true);
            outputLabel.setEnabled(true);
        }

        checkOptimizeButton();
    }

    //o͐tH_[
    public void do_outputButton() {
        DirectoryDialog dialog = new DirectoryDialog(shell, SWT.OPEN);
        String file = dialog.open();
        if (file != null) {
            outputLabel.setText(file);
        }
        
        checkOptimizeButton();
    }

    //obNAbv
    public void do_dobackup() {
        //System.out.println("dobackup");
    }


   
       
        
            public void do_optimizeButton() {
                optimizeButton.setEnabled(false);
                executing=true;
                
                String optiPngPath=optiPngLabel.getText();
                File optiPngFile=null;
                if(!optiPngPath.equals("")){
                    optiPngFile=new File(optiPngPath);
                    if(!optiPngFile.exists()){
                        optiPngFile=null;
                    }
                }
                if(optiPngFile==null){
                    //find directPath
                    
                    optiPngFile=searchFileAroundClass("optipng.exe");
                   
                }
                
                if(optiPngFile==null){
                    //alert
                    MessageBox dialog=new MessageBox(shell,SWT.ICON_ERROR);
                    dialog.setText("G[");
                    dialog.setMessage("optipng.exe ܂");
                    dialog.open();
                }else{
                    executer=new OptiPNGExecuter();
                    executer.setOptipngPath(optiPngFile.getAbsolutePath());
                    executer.setLevel(level.getText());
                    executer.setDoBackup(dobackup.getSelection());
                    executer.setBackupExtension(".bk");
                    if(outputLabel.getText().length()>0 && !sameoutput.getSelection()){
                        executer.setOutput(new File(outputLabel.getText()));
                    }
                    
                    String files[]=listTable.getFiles();
                    for(int i=0;i<files.length;i++){
                        executer.addFile(files[i]);
                    }
                    
                    
                   
                    
                    thread.start();
                    
                }
                
                
            
        
    
}
           
            
            public class wakeUpper extends Thread{
                public void run(){
                    DoWake wake=new DoWake();
                    while(executing){
                    shell.getDisplay().wake();
                    //shell.getDisplay().readAndDispatch();
                    System.out.println("waveup");
                    //shell.getDisplay().readAndDispatch();
                   shell.getDisplay().asyncExec(wake);
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException e) {
                        // TODO Auto-generated catch block
                        e.printStackTrace();
                    }
                    
                    }
                }
            }
            
            public class DoWake implements Runnable{
                public void run(){
                    System.out.println("read1");
                    shell.getDisplay().readAndDispatch();
                    System.out.println("read2");
                }
            }
    
    public class CreateResultDialog implements Runnable{
        private ResultData[] data;

         CreateResultDialog(ResultData[] data){
            this.data=data;
        }
        /* (non-Javadoc)
         * @see java.lang.Runnable#run()
         */
        public void run() {
            // TODO Auto-generated method stub
            Shell childShell=new Shell(shell);
            ResultDialog dialog=new ResultDialog(childShell);
            dialog.setResultData(data);
            childShell.open();
            
            optimizeButton.setEnabled(true);
        }
        
    }
    //œK
   

    //null1
    public void do_table1() {
        System.out.println("table1");
    }

    //null1
    public void do_menu1() {
        System.out.println("menu1");
    }

    //t@Cǉ
    public void do_addFileMenu() {
        System.out.println("addFileMenu");
    }

    //tH_[ǉ
    public void do_addFolderMenu() {
        System.out.println("addFolderMenu");
    }

    //Level
    public void do_level() {
        System.out.println("level");
    }

    //optiPngpX
    public void do_optiPngButton() {
        System.out.println("op");
       FileDialog dialog=new FileDialog(shell,SWT.OPEN);
       String filename[]={"optipng.exe"};
       dialog.setFilterExtensions(filename);
       String path=dialog.open();
       if(path!=null){
           optiPngLabel.setText(path);
       }
    }

    public class DropMonitor extends DropTargetAdapter {
        public void dragEnter(DropTargetEvent event) {
            //System.out.println("drag enter:"+event.data);
        }

        public void dragOver(DropTargetEvent event) {
            //System.out.println("drag over:"+event.data);
        }

        public void drop(DropTargetEvent event) {
            //System.out.println("drop:"+event.data);

            //System.out.println(event.data.getClass().getName());
            String files[] = (String[]) event.data;
            String tmpText = "";
            for (int i = 0; i < files.length; i++) {
                File file = new File(files[i]);
                if (file.isDirectory()) {
                    outputLabel.setText(files[i]);
                }

            }

        }
    }

    /* (non-Javadoc)
     * @see optipng.FileListChangeListener#removeList(optipng.FileListChangeEvent)
     */
    public void removeList(FileStatusChangeEvent event) {
        checkOptimizeButton();}

    
    /**
     * 
     */
    private boolean executing=false;
    private void checkOptimizeButton() {
        if(!executing){
        if(listTable.getFileCount()>0 && (sameoutput.getSelection() || outputLabel.getText().length()>0)){
            optimizeButton.setEnabled(true);
        }else{
            optimizeButton.setEnabled(false);
        }
        }else{
            optimizeButton.setEnabled(false);
        }
    }

    /* (non-Javadoc)
     * @see optipng.FileListChangeListener#addList(optipng.FileListChangeEvent)
     */
    public void addList(FileStatusChangeEvent event) {
      //System.out.println("add "+event.getFilePath());
        checkOptimizeButton();
    }
    
    public  File searchFileAroundClass(String fileName) {
        ClassLoader loader = this.getClass().getClassLoader();
        String path = this.getClass().getName().replaceAll("\\.", "/");
        path = path + ".class";

        URL url = loader.getResource(path);
        String classPath = url.toString();
        //System.out.println(classPath);
        if (classPath.startsWith("jar:")) {
            int last = classPath.lastIndexOf("!");
            classPath = classPath.substring("jar:".length(), last);
        }

        if (classPath.startsWith("file:/")) {
            File checkFile = new File(URLDecoder.decode(classPath
                    .substring("file:/".length()))).getParentFile();
            while (true) {
                File tmp = new File(checkFile, fileName);
                //	System.out.println(tmp.getAbsolutePath());
                if (tmp.exists()) {
                    return tmp;
                }

                else {
                    checkFile = checkFile.getParentFile();
                    if (checkFile == null) {
                        break;
                    }

                }
            }
            return null;
        } else {
            return null;
        }
    }

}